/*  -r1.6 sdlcmain.h
    @(#) module: sdlcmain.h, version: 1.6, retrieved: 01/12/04 18:38:26 */

/*
 *  Vers Description:											Date:	   By:
 * ===== ====================================================== ========== ====
 *  1.5  MAXNODES increased from 7 to 32.						10-07-2001 jfk
 *		 Default tty-path is Operating System Dependent.
 *	1.6	 Adapted to script 'buildsd'.							28-11-2001 jfk
 */

/*
 * Length of string constant SWRNUMBER is limited to the space
 * reserved in string variable 'VersionMsg[]'.
 */
#ifndef SWRNUMBER
#define SWRNUMBER	"dead"
#endif

/*
 * String constants BUILDDATE and VERSIONMSG have no length limitation.
 */
#ifndef BUILDDATE
#define BUILDDATE	__DATE__
#endif

#define	MAXNODES	32			/* maximum number of devices */
#define	DEFNODES	2			/* default number of devices */
#define RESLOGTIME	10			/* logtime resolution in seconds */
#define	FIFOTIMOUT	50			/* default time out value(msec) fifo input */
#define MAXFIFOTIMOUT 3000		/* max. timout for sd to wait for response database */
#define	POLLRETRIES	5			/* SG10/20 maximum poll retries */

#define	SG10		0xff		/* device type definition */
#define	SG20		0xfe


#define FIFOMODE	(O_CREAT|O_WRONLY)	/* create fifo with flags pwr------- */

/*
 * Definition of fifo's is given from the view of the external task which
 * is responsible for creating, reading from or writing to data to fifo.
 */
#define OUTFIFO		"soutfifo"
#define INFIFO		"sinfifo"
#define POUTFIFO	"poutfifo"

#define	MAXLINESZ	128

#define RECEIVE 0
#define XMIT	1

#define HIGH	1
#define LOW		0

#define BYTE	unsigned char
#define WORD	unsigned short

#define BIT0	1
#define BIT1	(1 << 1)
#define BIT2	(1 << 2)
#define BIT3	(1 << 3)
#define BIT4	(1 << 4)
#define BIT5	(1 << 5)
#define BIT6	(1 << 6)
#define BIT7	(1 << 7)
#define BIT8	(1 << 8)
#define BIT9	(1 << 9)
#define BIT10	(1 << 10)
#define BIT11	(1 << 11)
#define BIT12	(1 << 12)
#define BIT13	(1 << 13)
#define BIT14	(1 << 14)
#define BIT15	(1 << 15)
#define BIT31	0x80000000 	/* sco compiler feels happy with this notation */

#define EOFF	0x7e		/* End Of Frame Flag */
#define StdIn	0
#define	StdOut	1

#define FRAMSIZ		256
#define MAXTIMOUT	4

#define B_RXCRC		BIT0
#define B_TXCNT		BIT1
#define B_RXCNT		BIT2
#define B_TIMOUT	BIT3
#define B_SYNC		BIT4
#define B_READ		BIT5
#define B_SDLC		BIT6
#define B_MAXRETRY	BIT7

#define ERRORMSK	0xff
#define	E_RXCRC		(BIT0 << 8)
#define	E_TXCNT		(BIT1 << 8)
#define	E_RXCNT		(BIT2 << 8)
#define	E_TIMOUT	(BIT3 << 8)
#define E_SYNC		(BIT4 << 8)
#define E_READ		(BIT5 << 8)
#define E_SDLC		(BIT6 << 8)
#define	E_MAXRETRY	(BIT7 << 8)
#define	E_UNKNWN	(BIT8 << 8)

#define POLLTIMOUT	50		/* a shorter time-out makes solaris complain about timout's */

/*
 * First 8 bits of Error int are used for string indexing code tracing point.
 */ 
#define POLLFRAME_1		0
#define POLLFRAME_2		1
#define POLLFRAME_3		2
#define POLLFRAME_4		3
#define POLLFRAME_5		4
#define POLLFRAME_6		5
#define SDREAD_1		6
#define SDREAD_2		7
#define SDREAD_3		8
#define SENDIFRAMEACK_1	9
#define SENDICMD_1		10

#define B_RTS		BIT0
#define B_19K2		BIT1
#define B_FORMAT	BIT2
#define B_SG10		BIT3
#define B_FIFOS		BIT4

struct SDConfig {
	BYTE Flags[4];			/* contains a number of flags and settings */
	char devpath[256];		/* path that leads to requested tty device */
	char logfile[16];		/* name of optional logfile */
};

void tsleep(unsigned int nmsec);
int sdlc(BYTE Mode, BYTE Buf[]);

enum    sdlcCmds { sdOPEN, sdCLOSE, sdWRITE, sdSWRITE, sdREAD, sdSREAD };
